const INSTTIME_PREF_SHOW_DIALOG     = "dafi.installtimeout.showDialog";
const INSTTIME_PREF_SECONDS_COUNT   = "dafi.installtimeout.secondsCount";
const INSTTIME_XPINSTALL_DIALOG     = "xpinstall.dialog.confirm";
const INSTTIME_MOZ_MILLISECS_COUNT  = "security.dialog_enable_delay";

function InstallTimeOutPrefs() {
    this.prefBranch = Components.classes['@mozilla.org/preferences-service;1']
                      .getService(Components.interfaces.nsIPrefService)
                      .getBranch(null)
                      .QueryInterface(Components.interfaces.nsIPrefBranch);
    this._secondsCount = this.getInt(INSTTIME_PREF_SECONDS_COUNT, 0);
    this._showDialog = this.getBool(INSTTIME_PREF_SHOW_DIALOG);

}

InstallTimeOutPrefs.prototype = {
    getInt : function(prefName, defValue) {
        var prefValue;
        try {
            prefValue = this.prefBranch.getIntPref(prefName);
        } catch (ex) {
            prefValue = null;
        }
        return prefValue == null ? defValue : prefValue;
    },

    setInt : function(prefName, prefValue) {
        this.prefBranch.setIntPref(prefName, prefValue);
    },

    getBool : function(prefName, defValue) {
        var prefValue = false;
        try {
            prefValue = this.prefBranch.getBoolPref(prefName);
        } catch (ex) {
            if (defValue != undefined) {
                prefValue = defValue;
            }
        }

        return prefValue;
    },

    setBool : function(prefName, prefValue) {
        this.prefBranch.setBoolPref(prefName, prefValue);
    },

    getString : function(prefName, defValue) {
        var prefValue;
        try {
            prefValue = this.prefBranch.getCharPref(prefName);
        } catch (ex) {
            prefValue = null;
        }
        return prefValue == null ? defValue : prefValue;
    },

    setString : function(prefName, prefValue) {
        this.prefBranch.setCharPref(prefName, prefValue);
    },

    get showDialog() {
        return this._showDialog;
    },

    set showDialog(b) {
        this._showDialog = b;
    },
    
    get secondsCount() {
        return this._secondsCount;
    },
    
    set secondsCount(b) {
        if (b < 0) {
            b = 5;
        }
        this._secondsCount = b;
    },
            
    savePrefs : function() {
        this.setInt(INSTTIME_PREF_SECONDS_COUNT, this._secondsCount);
        //this.setInt(INSTTIME_MOZ_MILLISECS_COUNT, this._secondsCount * 1000);
        this.setBool(INSTTIME_PREF_SHOW_DIALOG, this._showDialog);
    },

    unregister : function() {
        this.prefBranch.clearUserPref(INSTTIME_XPINSTALL_DIALOG);
        //this.prefBranch.clearUserPref(INSTTIME_MOZ_MILLISECS_COUNT);
    },
    
    register : function() {
        this.setString(INSTTIME_XPINSTALL_DIALOG,
                "chrome://installtimeout/content/xpinstallConfirm.xul");
    }
}
